<?php
/**
 * @package Free Demo Content
 * @since 1.0.0
 */

class HomeGardeningThemeWhizzie {

	protected $version = '1.1.0';

	/** @var string Current theme name, used as namespace in actions. */
	protected $home_gardening_theme_name = '';
	protected $home_gardening_theme_title = '';

	/** @var string Free Demo Content page slug and title. */
	protected $home_gardening_page_slug = '';
	protected $home_gardening_page_title = '';

	/** @var array Free Demo Content steps set by user. */
	protected $home_gardening_config_steps = array();

	/**
	 * Relative plugin url for this plugin folder
	 * @since 1.0.0
	 * @var string
	*/
	protected $home_gardening_plugin_url = '';
	protected $home_gardening_plugin_path = '';
	public $home_gardening_parent_slug;
	/**
	 * TGMPA instance storage
	 *
	 * @var object
	*/
	protected $home_gardening_tgmpa_instance;

	/**
	 * TGMPA Menu slug
	 *
	 * @var string
	*/
	protected $home_gardening_tgmpa_menu_slug = 'tgmpa-install-plugins';

	/**
	 * TGMPA Menu url
	 *
	 * @var string
	*/
	protected $home_gardening_tgmpa_url = 'themes.php?page=tgmpa-install-plugins';
	/**
	 * Constructor
	 *
	 * @param $home_gardening_config	Our config parameters
	*/
	public function __construct( $home_gardening_config ) {
		$this->set_vars( $home_gardening_config );
		$this->init();

		include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
	}

	/**
	 * Set some settings
	 * @since 1.0.0
	 * @param $home_gardening_config	Our config parameters
	*/
	public function set_vars( $home_gardening_config ) {

		require_once trailingslashit( WHIZZIE_DIR ) . 'tgm/tgm.php';

		if( isset( $home_gardening_config['home_gardening_page_slug'] ) ) {
			$this->home_gardening_page_slug = esc_attr( $home_gardening_config['home_gardening_page_slug'] );
		}
		if( isset( $home_gardening_config['home_gardening_page_title'] ) ) {
			$this->home_gardening_page_title = esc_attr( $home_gardening_config['home_gardening_page_title'] );
		}
		if( isset( $home_gardening_config['steps'] ) ) {
			$this->home_gardening_config_steps = $home_gardening_config['steps'];
		}

		$this->home_gardening_plugin_path = trailingslashit( dirname( __FILE__ ) );
		$relative_url = str_replace( get_template_directory(), '', $this->home_gardening_plugin_path );
		$this->home_gardening_plugin_url = trailingslashit( get_template_directory_uri() . $relative_url );
		$current_theme = wp_get_theme();
		$this->home_gardening_theme_title = $current_theme->get( 'Name' );
		$this->home_gardening_theme_name = strtolower( preg_replace( '#[^a-zA-Z]#', '', $current_theme->get( 'Name' ) ) );
		$this->home_gardening_page_slug = apply_filters( $this->home_gardening_theme_name . '_theme_setup_wizard_home_gardening_page_slug', $this->home_gardening_theme_name . '-freedemocontent' );
		$this->home_gardening_parent_slug = apply_filters( $this->home_gardening_theme_name . '_theme_setup_wizard_parent_slug', '' );
	}

	/**
	 * Hooks and filters
	 * @since 1.0.0
	*/
	public function init() {

		if ( class_exists( 'TGM_Plugin_Activation' ) && isset( $GLOBALS['tgmpa'] ) ) {
			add_action( 'init', array( $this, 'get_tgmpa_instance' ), 30 );
			add_action( 'init', array( $this, 'set_tgmpa_url' ), 40 );
		}

		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );
		// add_action( 'admin_menu', array( $this, 'menu_page' ) );
		add_action( 'admin_init', array( $this, 'get_plugins' ), 30 );
		add_filter( 'tgmpa_load', array( $this, 'tgmpa_load' ), 10, 1 );
		add_action( 'wp_ajax_setup_plugins', array( $this, 'setup_plugins' ) );
		add_action( 'wp_ajax_setup_widgets', array( $this, 'setup_widgets' ) );
	}

	public function enqueue_scripts() {
		wp_enqueue_style( 'home-gardening-free-demo-content-style', get_template_directory_uri() . '/inc/free-demo-content/css-and-js/free-demo-content-style.css');
		wp_register_script( 'home-gardening-free-demo-content-script', get_template_directory_uri() . '/inc/free-demo-content/css-and-js/free-demo-content-script.js', array( 'jquery' ), time() );
		wp_localize_script(
			'home-gardening-free-demo-content-script',
			'home_gardening_whizzie_params',
			array(
				'ajaxurl' 		=> admin_url( 'admin-ajax.php' ),
				'wpnonce' 		=> wp_create_nonce( 'whizzie_nonce' ),
				'verify_text'	=> esc_html( 'verifying', 'home-gardening' )
			)
		);
		wp_enqueue_script( 'home-gardening-free-demo-content-script' );
	}

	public function tgmpa_load( $status ) {
		return is_admin() || current_user_can( 'install_themes' );
	}

	/**
	 * Get configured TGMPA instance
	 *
	 * @access public
	 * @since 1.1.2
	*/
	public function get_tgmpa_instance() {
		$this->home_gardening_tgmpa_instance = call_user_func( array( get_class( $GLOBALS['tgmpa'] ), 'get_instance' ) );
	}

	/**
	 * Update $home_gardening_tgmpa_menu_slug and $tgmpa_parent_slug from TGMPA instance
	 *
	 * @access public
	 * @since 1.1.2
	*/
	public function set_tgmpa_url() {
		$this->home_gardening_tgmpa_menu_slug = ( property_exists( $this->home_gardening_tgmpa_instance, 'menu' ) ) ? $this->home_gardening_tgmpa_instance->menu : $this->home_gardening_tgmpa_menu_slug;
		$this->home_gardening_tgmpa_menu_slug = apply_filters( $this->home_gardening_theme_name . '_theme_setup_wizard_tgmpa_menu_slug', $this->home_gardening_tgmpa_menu_slug );
		$tgmpa_parent_slug = ( property_exists( $this->home_gardening_tgmpa_instance, 'home_gardening_parent_slug' ) && $this->home_gardening_tgmpa_instance->home_gardening_parent_slug !== 'themes.php' ) ? 'admin.php' : 'themes.php';
		$this->home_gardening_tgmpa_url = apply_filters( $this->home_gardening_theme_name . '_theme_setup_wizard_tgmpa_url', $tgmpa_parent_slug . '?page=' . $this->home_gardening_tgmpa_menu_slug );
	}


	/**  Make a modal screen for the wizard **/
	// public function menu_page() {
	// 	add_theme_page( esc_html( $this->home_gardening_page_title ), esc_html( $this->home_gardening_page_title ), 'manage_options', $this->home_gardening_page_slug, array( $this, 'home_gardening_guide' ) );
	// }

	/*** Make an interface for the wizard ***/
	public function Home_Gardening_Demo_Content_Page() {

		tgmpa_load_bulk_installer();

		// install plugins with TGM.
		if ( ! class_exists( 'TGM_Plugin_Activation' ) || ! isset( $GLOBALS['tgmpa'] ) ) {
			die( 'Failed to find TGM' );
		}
		$home_gardening_url = wp_nonce_url( add_query_arg( array( 'plugins' => 'go' ) ), 'whizzie-setup' );

		// copied from TGM
		$home_gardening_method = ''; // Leave blank so WP_Filesystem can populate it as necessary.
		$home_gardening_fields = array_keys( $_POST ); // Extra fields to pass to WP_Filesystem.
		if ( false === ( $creds = request_filesystem_credentials( esc_url_raw( $home_gardening_url ), $home_gardening_method, false, false, $home_gardening_fields ) ) ) {
			return true; // Stop the normal page form from displaying, credential request form will be shown.
		}
		// Now we have some credentials, setup WP_Filesystem.
		if ( ! WP_Filesystem( $creds ) ) {
			// Our credentials were no good, ask the user for them again.
			request_filesystem_credentials( esc_url_raw( $home_gardening_url ), $home_gardening_method, true, false, $home_gardening_fields );
			return true;
		}

		/* If we arrive here, we have the filesystem */ ?>
		<div class="wrap">
			<?php echo '<div class="whizzie-wrap">';
				// The wizard is a list with only one item visible at a time
				$home_gardening_steps = $this->get_steps();
				echo '<div class="abcd">';

					echo '<ul class="whizzie-nav wizard-icon-nav nav-tab-wrapper clearfix">';?>

					<?php
						$home_gardening_stepI=1;
						foreach( $home_gardening_steps as $home_gardening_step ) {
							$home_gardening_stepAct=($home_gardening_stepI ==1)? 1 : 0;
							if( isset( $home_gardening_step['icon_text'] ) && $home_gardening_step['icon_text'] ) {
								echo '<li class="commom-cls nav-step-' . esc_attr( $home_gardening_step['id'] ) . '" wizard-steps="step-'.esc_attr( $home_gardening_step['id'] ).'" data-enable="'.$home_gardening_stepAct.'">
								<a class="nav-tab upgrade-button">'.esc_attr( $home_gardening_step['icon_text'] ).'</a>
								</li>';
							}
						$home_gardening_stepI++;}

					echo '</ul>';
			 	echo '</div>';

				echo '<div class="second-div">';
					echo '<ul class="whizzie-menu wizard-menu-page theme-details">';
					foreach( $home_gardening_steps as $home_gardening_step ) {
						$home_gardening_class = 'step step-' . esc_attr( $home_gardening_step['id'] );
						echo '<li data-step="' . esc_attr( $home_gardening_step['id'] ) . '" class="' . esc_attr( $home_gardening_class ) . '" >';

							$home_gardening_content = call_user_func( array( $this, $home_gardening_step['view'] ) );
							if( isset( $home_gardening_content['summary'] ) ) {
								printf(
									'<div class="summary">%s</div>',
									wp_kses_post( $home_gardening_content['summary'] )
								);
							}
							if( isset( $home_gardening_content['detail'] ) ) {
								// Add a link to see more detail
								printf( '<div class="wz-require-plugins">');
								printf(
									'<div class="detail">%s</div>',
									$home_gardening_content['detail'] // Need to escape this
								);
								printf('</div>');
							}
							printf('<div class="wizard-button-wrapper">');
								// The next button
								if( isset( $home_gardening_step['button_text'] ) && $home_gardening_step['button_text'] ) {
									printf(
										'<div class="button-wrap"><a href="#" class="button button-primary do-it" data-callback="%s" data-step="%s">%s</a></div>',
										esc_attr( $home_gardening_step['callback'] ),
										esc_attr( $home_gardening_step['id'] ),
										esc_html( $home_gardening_step['button_text'] )
									);
								}

								if( isset( $home_gardening_step['button_text_one'] )) {
									printf(
										'<div class="button-wrap button-wrap-one">
											<a href="#" class="button button-primary do-it" data-callback="install_widgets" data-step="widgets"><p class="demo-type-text">%s</p></a>
										</div>',
										esc_html( $home_gardening_step['button_text_one'] )
									);
								}
							printf('</div>');
						echo '</li>';
					}
					echo '</ul>';

				echo '</div>';
				?>
			<?php echo '</div>';?>
		</div>
	<?php }

	/**
	 * Set options for the steps
	 * @return Array
	*/
	public function get_steps() {
		$home_gardening_dev_steps = $this->home_gardening_config_steps;
		$home_gardening_steps = array(
			'plugins' => array(
				'id'			=> 'plugins',
				'title'			=> __( 'Plugins', 'home-gardening' ),
				'icon'			=> 'admin-plugins',
				'view'			=> 'get_step_plugins',
				'callback'		=> 'install_plugins',
				'button_text'	=> __( 'Install Plugins', 'home-gardening' ),
				'can_skip'		=> true,
				'icon_text'      => 'Plugins'
			),
			'widgets' => array(
				'id'			=> 'widgets',
				'title'			=> __( 'Customizer', 'home-gardening' ),
				'icon'			=> 'welcome-widgets-menus',
				'view'			=> 'get_step_widgets',
				'callback'		=> 'install_widgets',
				'button_text_one'	=> __( 'Import Demo Content', 'home-gardening' ),

				'can_skip'		=> true,
				'icon_text'      => 'Import Demo Content'
			),
			'done' => array(
				'id'			=> 'done',
				'title'			=> __( 'All Done', 'home-gardening' ),
				'icon'			=> 'yes',
				'view'			=> 'get_step_done',
				'callback'		=> '',
				'icon_text'      => 'Done'
			)
		);

		// Iterate through each step and replace with dev config values
		if( $home_gardening_dev_steps ) {
			// Configurable elements - these are the only ones the dev can update from config.php
			$can_config = array( 'title', 'icon', 'button_text', 'can_skip' );
			foreach( $home_gardening_dev_steps as $dev_step ) {
				// We can only proceed if an ID exists and matches one of our IDs
				if( isset( $dev_step['id'] ) ) {
					$id = $dev_step['id'];
					if( isset( $home_gardening_steps[$id] ) ) {
						foreach( $can_config as $element ) {
							if( isset( $dev_step[$element] ) ) {
								$home_gardening_steps[$id][$element] = $dev_step[$element];
							}
						}
					}
				}
			}
		}
		return $home_gardening_steps;
	}

	/*** Print the content for the intro step ***/
		public function get_step_importer() { ?>
		<div class="summary">
			<p>
				<?php esc_html_e('Thank you for choosing this Home Gardening Theme. Using this quick setup wizard, you will be able to configure your new website and get it running in just a few minutes. Just follow these simple steps mentioned in the wizard and get started with your website.','home-gardening'); ?>
			</p>
		</div>
	<?php }

	/**
	 * Get the content for the plugins step
	 * @return $home_gardening_content Array
	*/
	public function get_step_plugins() {
		$plugins = $this->get_plugins();
		$home_gardening_content = array(); ?>
			<div class="summary">
				<p>
					<?php esc_html_e('Install Recommended Plugins:	','home-gardening') ?>
				</p>
			</div>
		<?php // The detail element is initially hidden from the user
		$home_gardening_content['detail'] = '<span class="wizard-plugin-count">'.count($plugins['all']).'</span><ul class="whizzie-do-plugins">';
		// Add each plugin into a list
		foreach( $plugins['all'] as $slug=>$plugin ) {
			$home_gardening_content['detail'] .= '<li data-slug="' . esc_attr( $slug ) . '">' . esc_html( $plugin['name'] ) . '<div class="wizard-plugin-title">';

			$home_gardening_content['detail'] .= '<span class="wizard-plugin-status">Installation Required</span><i class="spinner"></i></div></li>';
		}
		$home_gardening_content['detail'] .= '</ul>';

		return $home_gardening_content;
	}

	/**    Print the content for the intro step     **/
	public function get_step_widgets() { ?>
		<div class="summary">
			<p>
				<?php esc_html_e('This theme allows you to Import Demo Content content and add widgets. Install them using the button below. You can also update or deactivate them using the Customizer.','home-gardening'); ?>
			</p>
		</div>
	<?php }

	/***  Print the content for the final step  ***/
	public function get_step_done() { ?>

		<div class="setup-finish">
			<p>
				<?php echo esc_html('Your demo content has been imported successfully. Click the finish button for more information.'); ?>
			</p>
			<div class="finish-buttons">
				<a href="<?php echo esc_url( admin_url( 'themes.php?page=home-gardening-themeinfo-page' ) ); ?>" class="wz-btn-customizer" target="_blank"><?php esc_html_e('Home Gardening Info','home-gardening') ?></a>
				<a href="<?php echo esc_url(admin_url('/customize.php')); ?>" class="wz-btn-customizer" target="_blank"><?php esc_html_e('Customizer Settings','home-gardening') ?></a>
				<a href="" class="wz-btn-builder" target="_blank"><?php esc_html_e('Customize Your Demo','home-gardening'); ?></a>
				<a href="<?php echo esc_url(home_url()); ?>" class="wz-btn-visit-site" target="_blank"><?php esc_html_e('Visit Your Site','home-gardening'); ?></a>
			</div>
			<div class="finish-buttons">
				<a href="<?php echo esc_url(admin_url()); ?>" class="button button-primary"><?php esc_html_e('Finish','home-gardening'); ?></a>
			</div>
		</div>

	<?php }

	/***  Get the plugins registered with TGMPA  ***/
	public function get_plugins() {
		$instance = call_user_func( array( get_class( $GLOBALS['tgmpa'] ), 'get_instance' ) );
		$plugins = array(
			'all' 		=> array(),
			'install'	=> array(),
			'update'	=> array(),
			'activate'	=> array()
		);
		foreach( $instance->plugins as $slug=>$plugin ) {
			if( $instance->is_plugin_active( $slug ) && false === $instance->does_plugin_have_update( $slug ) ) {
				// Plugin is installed and up to date
				continue;
			} else {
				$plugins['all'][$slug] = $plugin;
				if( ! $instance->is_plugin_installed( $slug ) ) {
					$plugins['install'][$slug] = $plugin;
				} else {
					if( false !== $instance->does_plugin_have_update( $slug ) ) {
						$plugins['update'][$slug] = $plugin;
					}
					if( $instance->can_plugin_activate( $slug ) ) {
						$plugins['activate'][$slug] = $plugin;
					}
				}
			}
		}
		return $plugins;
	}

	public function setup_plugins() {
		if ( ! check_ajax_referer( 'whizzie_nonce', 'wpnonce' ) || empty( $_POST['slug'] ) ) {
			wp_send_json_error( array( 'error' => 1, 'message' => esc_html__( 'No Slug Found','home-gardening' ) ) );
		}
		$json = array();
		// send back some json we use to hit up TGM
		$plugins = $this->get_plugins();

		// what are we doing with this plugin?
		foreach ( $plugins['activate'] as $slug => $plugin ) {
			if ( $_POST['slug'] == $slug ) {
				$json = array(
					'url'           => admin_url( $this->home_gardening_tgmpa_url ),
					'plugin'        => array( $slug ),
					'tgmpa-page'    => $this->home_gardening_tgmpa_menu_slug,
					'plugin_status' => 'all',
					'_wpnonce'      => wp_create_nonce( 'bulk-plugins' ),
					'action'        => 'tgmpa-bulk-activate',
					'action2'       => - 1,
					'message'       => esc_html__( 'Activating Plugin','home-gardening' ),
				);
				break;
			}
		}
		foreach ( $plugins['update'] as $slug => $plugin ) {
			if ( $_POST['slug'] == $slug ) {
				$json = array(
					'url'           => admin_url( $this->home_gardening_tgmpa_url ),
					'plugin'        => array( $slug ),
					'tgmpa-page'    => $this->home_gardening_tgmpa_menu_slug,
					'plugin_status' => 'all',
					'_wpnonce'      => wp_create_nonce( 'bulk-plugins' ),
					'action'        => 'tgmpa-bulk-update',
					'action2'       => - 1,
					'message'       => esc_html__( 'Updating Plugin','home-gardening' ),
				);
				break;
			}
		}
		foreach ( $plugins['install'] as $slug => $plugin ) {
			if ( $_POST['slug'] == $slug ) {
				$json = array(
					'url'           => admin_url( $this->home_gardening_tgmpa_url ),
					'plugin'        => array( $slug ),
					'tgmpa-page'    => $this->home_gardening_tgmpa_menu_slug,
					'plugin_status' => 'all',
					'_wpnonce'      => wp_create_nonce( 'bulk-plugins' ),
					'action'        => 'tgmpa-bulk-install',
					'action2'       => - 1,
					'message'       => esc_html__( 'Installing Plugin','home-gardening' ),
				);
				break;
			}
		}
		if ( $json ) {
			$json['hash'] = md5( serialize( $json ) ); // used for checking if duplicates happen, move to next plugin
			wp_send_json( $json );
		} else {
			wp_send_json( array( 'done' => 1, 'message' => esc_html__( 'Success','home-gardening' ) ) );
		}
		exit;
	}


	//. - . - . - . - . - . - . - . - . - . - . - . - . MENUS . - . - . - . - . - . - . - . - . - . - . - . - .//
	
	public function Home_Gardening_Customizer_Header_Menu() {
		// ------- Create Primary Menu --------
		$home_gardening_themename = 'Home Gardening'; // Ensure the theme name is set
		$home_gardening_menuname = $home_gardening_themename . ' Primary Menu';
		$home_gardening_menulocation = 'menu-1';
		$home_gardening_menu_exists = wp_get_nav_menu_object($home_gardening_menuname);

		if (!$home_gardening_menu_exists) {
			$home_gardening_menu_id = wp_create_nav_menu($home_gardening_menuname);

			// Home
			wp_update_nav_menu_item($home_gardening_menu_id, 0, array(
				'menu-item-title' => __('Home', 'home-gardening'),
				'menu-item-classes' => 'home',
				'menu-item-url' => home_url('/'),
				'menu-item-status' => 'publish'
			));

			// About
			$home_gardening_page_about = get_page_by_path('about');
			if($home_gardening_page_about){
				wp_update_nav_menu_item($home_gardening_menu_id, 0, array(
					'menu-item-title' => __('About', 'home-gardening'),
					'menu-item-classes' => 'about',
					'menu-item-url' => get_permalink($home_gardening_page_about),
					'menu-item-status' => 'publish'
				));
			}

			// Page
			$home_gardening_page_Page = get_page_by_path('Page');
			if($home_gardening_page_Page){
				wp_update_nav_menu_item($home_gardening_menu_id, 0, array(
					'menu-item-title' => __('Page', 'home-gardening'),
					'menu-item-classes' => 'Page',
					'menu-item-url' => get_permalink($home_gardening_page_Page),
					'menu-item-status' => 'publish'
				));
			}

			// Blog
			$home_gardening_page_blog = get_page_by_path('blog');
			if($home_gardening_page_blog){
				wp_update_nav_menu_item($home_gardening_menu_id, 0, array(
					'menu-item-title' => __('Blog', 'home-gardening'),
					'menu-item-classes' => 'blog',
					'menu-item-url' => get_permalink($home_gardening_page_blog),
					'menu-item-status' => 'publish'
				));
			}

			// Contact Us
			$home_gardening_page_contact = get_page_by_path('contact');
			if($home_gardening_page_contact){
				wp_update_nav_menu_item($home_gardening_menu_id, 0, array(
					'menu-item-title' => __('Contact Us', 'home-gardening'),
					'menu-item-classes' => 'contact',
					'menu-item-url' => get_permalink($home_gardening_page_contact),
					'menu-item-status' => 'publish'
				));
			}

			// Assign menu to location if not set
			if (!has_nav_menu($home_gardening_menulocation)) {
				$home_gardening_locations = get_theme_mod('nav_menu_locations');
				$home_gardening_locations[$home_gardening_menulocation] = $home_gardening_menu_id; // Use $home_gardening_menu_id here
				set_theme_mod('nav_menu_locations', $home_gardening_locations);
			}
		}
	}


	/**
	* Imports the Demo Content
	* @since 1.1.0
	*/
	public function setup_widgets() {

		//. - . - . - . - . - . - . - . - . - . - . - . - . MENU PAGES . - . - . - . - . - . - . - . - . - . - . - . - .//
		
			$home_gardening_home_id='';
			$home_gardening_home_content = '';

			$home_gardening_home_title = 'Home';
			$home_gardening_home = array(
					'post_type' => 'page',
					'post_title' => $home_gardening_home_title,
					'post_content'  => $home_gardening_home_content,
					'post_status' => 'publish',
					'post_author' => 1,
					'post_slug' => 'home'
			);
			$home_gardening_home_id = wp_insert_post($home_gardening_home);

			//Set the home page template
			add_post_meta( $home_gardening_home_id, '_wp_page_template', 'default-home.php' );

			//Set the static front page
			$home_gardening_home = get_page_by_title( 'Home' );
			update_option( 'page_on_front', $home_gardening_home->ID );
			update_option( 'show_on_front', 'page' );


			// Create a posts page and assign the template
			$home_gardening_blog_title = 'Blog';
			$home_gardening_blog_check = get_page_by_path('blog');
			if (!$home_gardening_blog_check) {
				$home_gardening_blog = array(
					'post_type'    => 'page',
					'post_title'   => $home_gardening_blog_title,
					'post_status'  => 'publish',
					'post_author'  => 1,
					'post_name'    => 'blog'
				);
				$home_gardening_blog_id = wp_insert_post($home_gardening_blog);

				// Set the posts page
				if (!is_wp_error($home_gardening_blog_id)) {
					update_option('page_for_posts', $home_gardening_blog_id);
				}
			}

			// Create a Contact Us page and assign the template
			$home_gardening_contact_title = 'Contact Us';
			$home_gardening_contact_check = get_page_by_path('contact');
			if (!$home_gardening_contact_check) {
				$home_gardening_contact = array(
					'post_type'    => 'page',
					'post_title'   => $home_gardening_contact_title,
					'post_status'  => 'publish',
					'post_content'   => 'Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum.',
					'post_author'  => 1,
					'post_name'    => 'contact'
				);
				wp_insert_post($home_gardening_contact);
			}

			// Create a About page and assign the template
			$home_gardening_about_title = 'About';
			$home_gardening_about_check = get_page_by_path('about');
			if (!$home_gardening_about_check) {
				$home_gardening_about = array(
					'post_type'    => 'page',
					'post_title'   => $home_gardening_about_title,
					'post_status'  => 'publish',
					'post_content'   => 'Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum.',
					'post_author'  => 1,
					'post_name'    => 'about'
				);
				wp_insert_post($home_gardening_about);
			}

			// Create a Page page and assign the template
			$home_gardening_Page_title = 'Page';
			$home_gardening_Page_check = get_page_by_path('Page');
			if (!$home_gardening_Page_check) {
				$home_gardening_Page = array(
					'post_type'    => 'page',
					'post_title'   => $home_gardening_Page_title,
					'post_status'  => 'publish',
					'post_content'   => 'Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum.',
					'post_author'  => 1,
					'post_name'    => 'Page'
				);
				wp_insert_post($home_gardening_Page);
			}

			
		//. - . - . - . - . - . - . - . - . - . - . - . - . FRONTPAGE CONTENT . - . - . - . - . - . - . - . - . - . - . - . - .//

			set_theme_mod('home_gardening_facebook_url','#');
			set_theme_mod('home_gardening_twitter_url','#');
			set_theme_mod('home_gardening_instagram_url','#');
			set_theme_mod('home_gardening_youtube_url','#');
			set_theme_mod('home_gardening_whatsapp_url','#');


			set_theme_mod('home_gardening_banner_section_on_off_setting',true);
			set_theme_mod('home_gardening_topbar_section_on_off_setting',true);
			set_theme_mod('home_gardening_services_section_on_off_setting',true);


			set_theme_mod('home_gardening_slider',3);
	
			$home_gardening_diff_headings = array(
				'Transform Your Garden with Lush Green Beauty',
				'Grow Naturally, Live Beautifully',
				'Eco-Friendly Gardening for a Healthier Tomorrow'
			);

			for($home_gardening_i=1;$home_gardening_i<=3;$home_gardening_i++){
				set_theme_mod('home_gardening_banner_heading'.$home_gardening_i, $home_gardening_diff_headings[$home_gardening_i - 1]);
				set_theme_mod( 'home_gardening_banner_heading_text'.$home_gardening_i, 'Welcome Back GreenHoven Gardens' );
				set_theme_mod( 'home_gardening_banner_content'.$home_gardening_i, 'The global energy landscape will change more in the next 10 years than in the previous hundred.' );
				set_theme_mod( 'home_gardening_banner_btn'.$home_gardening_i, 'Send Question' );
				set_theme_mod( 'home_gardening_banner_button_link'.$home_gardening_i, '#' );
				set_theme_mod( 'home_gardening_banner_image'.$home_gardening_i,get_template_directory_uri().'/assets/images/slider.png' );
			}


			set_theme_mod('home_gardening_video_count','10M');
			set_theme_mod('home_gardening_video_count_text','Worldwide product sales per year');
			set_theme_mod('home_gardening_video_embed_url','https://www.youtube.com/embed/Z7GCYG9YeT8?si=U-_6hsAa1a_knOK3');
			set_theme_mod('home_gardening_video_rightside_text','From full automation to top-class tech innovation');


			set_theme_mod('home_gardening_services_short_title','SUCCESSFUL GARDEN TRANSFORMATIONS');
			set_theme_mod('home_gardening_services_title','A Garden Legacy That Flourishes.');
			set_theme_mod('home_gardening_services_count','6');

			$home_gardening_services_heading = array(
				'Landscape Design',
				'Vertical Gardening',
				'Organic Farming',
				'Lawn Maintenance',
				'Garden Cleanup',
				'Irrigation Solutions'
			);

			$home_gardening_services_icon = array(
				'fas fa-seedling',
				'fas fa-border-style',
				'fas fa-apple-alt',
				'fas fa-cut',
				'fas fa-trash-alt',
				'fas fa-water'
			);

			for($home_gardening_i=1;$home_gardening_i<=6;$home_gardening_i++){
				set_theme_mod('home_gardening_services_icon'.$home_gardening_i, $home_gardening_services_icon[$home_gardening_i - 1]);
				set_theme_mod('home_gardening_services_heading'.$home_gardening_i, $home_gardening_services_heading[$home_gardening_i - 1]);
				set_theme_mod( 'home_gardening_service_btn'.$home_gardening_i, 'Subscribe Now' );
				set_theme_mod( 'home_gardening_service_button_link'.$home_gardening_i, '#' );
				set_theme_mod('home_gardening_services_image' . $home_gardening_i, get_template_directory_uri() . '/assets/images/services' . $home_gardening_i . '.png');
			}


		$this->Home_Gardening_Customizer_Header_Menu();
	}

	//guidline for about theme
	public function home_gardening_guide() {
		$display_string = '';
		//custom function about theme customizer
		$return = add_query_arg( array()) ;
		$theme = wp_get_theme( 'home-gardening' );
		?>
		<div class="wrapper-info wrap about-wrap access-wrap">
			<div class="tab-sec theme-option-tab">
				<div id="demo_offer" class="tabcontent open">
					<?php $this->Home_Gardening_Demo_Content_Page(); ?>
				</div>
			</div>
		</div>
		
	<?php }
}